/*
student              Paul Diac
complexitate timp    O(M + Q log Q)
complexitate memorie O(Q)
punctaj              100/100
cu numere mari
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define QMax 1005
#define CifMax 10005

FILE *fin = fopen("sir.in", "rt");
FILE *fout = fopen("sir.out", "wt");

int X0, A, B, M, Q;

typedef struct query
{
	int Qi, Pimod, XPi;
} query;
query q[QMax];
int Per;

int f(int X)
{
	return ((long long) A * X + B) % M;
}

int compPiMod(const void *a, const void *b)
{
	return (*(query *)a).Pimod - (*(query *)b).Pimod;
}
int compQi(const void *a, const void *b)
{
	return (*(query *)a).Qi - (*(query *)b).Qi;
}

char c[CifMax];
int piModPer()
{
	int rez = 0;
	int pow10 = 1;
	int len = strlen(c) - 2;
	for (int i = len; i >= 0; i--)
	{
		rez = rez + (c[i] - '0') * pow10;
		rez %= Per;

		pow10 = (pow10 * 10) % Per;
	}
	return rez;
}

int main()
{
	fscanf(fin, "%d %d %d %d %d\n", &X0, &A, &B, &M, &Q);

	int X = X0;
	int i = 0;

	for (; i == 0 || X != X0; i++)
		X = f(X);

	Per = i;

	for (i = 0; i < Q; i++)
	{
		fgets(c, CifMax, fin);
		q[i].Qi = i;
		q[i].Pimod = piModPer();
	}

	qsort(q, Q, sizeof(q[0]), compPiMod);
	int j = 0;
	X = X0;
	for (i = 0; i < Per; i++)
	{
		while (j < Q && q[j].Pimod == i)
		{
			q[j].XPi = X;
			j++;
		}
		X = f(X);
	}

	qsort(q, Q, sizeof(q[0]), compQi);

	for (i = 0; i < Q; i++)
		fprintf(fout, "%d ", q[i].XPi);
	fprintf(fout, "\n");

	fclose(fin);
	fclose(fout);
	return 0;
}
